"""
Various types of ALIEN CRITTERS.  I am Ignignat, and this is my associate, Ur.
"""
from Utils import *
from Constants import *
import Sprite
import Global
import math
import Sound
import Items

class AlienSprite(Sprite.AnimateSprite, Sprite.Bouncer):
    SpeedLimit = 5
    CanShoot = 0
    IsHostile = 1
    MaxHP = 1
    Acceleration = 0.0002
    ShotSpeed = 4
    SplitCount = 2
    SplitClass = None
    Name = ImageNames.GreenAlien
    def __init__(self, Name, X, Y):
        self.MySpeedLimit = self.SpeedLimit * (1.0 - (random.random() * 0.3))
        self.X = X
        self.Y = Y
        self.DX = 0
        self.DY = 0
        self.Damage = 300
        self.IsGrabbed = 0
        self.GrabX = 0
        self.GrabY = 0
        self.IsTossed = 0
        self.HP = self.MaxHP
        self.Init()
        Sprite.AnimateSprite.__init__(self, Name, X, Y, 5)
    def CrashIntoPlayer(self):
        self.HandleDeath()
        if Global.Objective.Type == ObjectiveType.KillType and isinstance(self, Global.Objective.Class):
            Global.Player.QuestProgress += 1
            Global.Screen.QuestUpdate()        
    def MoveTowardPlayer(self):
        DX = Global.PlayerSprite.X - self.X
        DY = Global.PlayerSprite.Y - self.Y
        self.DX += (DX * self.Acceleration)
        self.DY += (DY * self.Acceleration)
        self.DX = max(-self.MySpeedLimit, min(self.MySpeedLimit, self.DX))
        self.DY = max(-self.MySpeedLimit, min(self.MySpeedLimit, self.DY))
        self.X += self.DX
        self.Y += self.DY
        self.rect.center = (self.X, self.Y)
    def UpdateHostile(self): # SWAPPABLE
        self.MoveTowardPlayer()
        Sprite.AnimateSprite.Update(self)
    def UpdateShooter(self): # SWAPPABLE
        self.MoveTowardPlayer()
        self.ShotDelay = max(0, self.ShotDelay - 1)
        if self.ShotDelay <= 0:
            self.FireAtPlayer()
        Sprite.AnimateSprite.Update(self)
    def UpdateSniper(self): # SWAPPABLE
        self.WalkTowardSpot()
        self.ShotDelay = max(0, self.ShotDelay - 1)
        if self.ShotDelay <= 0:
            self.FireAtPlayer()
        Sprite.AnimateSprite.Update(self)
    def FireAtPlayer(self):
        DX = Global.PlayerSprite.X - self.X
        DY = Global.PlayerSprite.Y - self.Y        
        Angle = GetAngle(DX, DY)
        DX = math.cos(Angle) * self.ShotSpeed
        DY = math.sin(Angle) * self.ShotSpeed
        Shot = Sprite.ShotSprite(ImageNames.RedShot, self.X + DX*5, self.Y + DY*5,
                                 DX, DY)
        Shot.Damage = 100 # default
        Global.Screen.AllShotSprites.add(Shot)
        Global.Screen.ForegroundSprites.add(Shot)
        Global.Screen.MonsterShotSprites.add(Shot)
        Sound.PlaySound(SoundNames.MonsterShot)
        self.ShotDelay = 100 + random.randrange(800)
    def WallReact(self, Wall):
        self.IsTossed = 0
    def InitPeaceful(self): # INIT plugin
        self.WalkToX = random.randrange(30, Global.App.Width - 30)
        self.WalkToY = random.randrange(30, Global.Screen.Bottom - 30)
    def InitSniper(self): # INIT plugin
        self.WalkToX = random.randrange(30, Global.App.Width - 30)
        self.WalkToY = random.randrange(30, Global.Screen.Bottom - 30)
        self.ShotDelay = 100 + random.randrange(300)
    def InitBouncy(self):
        self.DX = self.SpeedLimit * random.randrange(20, 100) / 100.0
        self.DY = self.SpeedLimit * random.randrange(20, 100) / 100.0
    def Init(self): # SWAPPABLE
        pass
    def InitShooter(self):
        self.ShotDelay = 100 + random.randrange(100)
    def HandleDeath(self): # SWAPPABLE
        pass
    def DieStandard(self): # SWAPPABLE
        if self.IsGrabbed:
            Global.Player.CarriedCritter = None
        Sound.PlaySound(random.choice((SoundNames.MonsterDie, SoundNames.MonsterDie2)))
        Global.Screen.AddShrapnel(self.X, self.Y, 10)
        if random.random() <= Global.Screen.ItemRate:
            Item = Items.ItemSprite(self.X, self.Y)
            Global.Screen.ForegroundSprites.add(Item)
            Global.Screen.ItemSprites.add(Item)
            Global.Screen.BouncySprites.add(Item)
        self.kill()
    def UpdateBounce(self): #UPDATE plugin
        self.X += self.DX
        self.Y += self.DY
        self.rect.center = (self.X, self.Y)
        Sprite.AnimateSprite.Update(self)
    def DieSplit(self):
        Sound.PlaySound(random.choice((SoundNames.MonsterDie, SoundNames.MonsterDie2)))
        for Index in range(self.SplitCount):
            DX = random.randrange(-20, 21) / 5.0
            DY = random.randrange(-20, 21) / 5.0
            EvilDemonBaby = self.SplitClass(self.X + DX*2,
                                            self.Y + DY*2)
            EvilDemonBaby.Init()
            EvilDemonBaby.DX = DX
            EvilDemonBaby.DY = DY
            Global.Screen.ForegroundSprites.add(EvilDemonBaby)
            Global.Screen.MonsterSprites.add(EvilDemonBaby)
            Global.Screen.BouncySprites.add(EvilDemonBaby)
        self.kill()
    def WalkTowardSpot(self):
        DX = self.WalkToX - self.X
        DY = self.WalkToY - self.Y
        self.DX += (DX * self.Acceleration)
        self.DY += (DY * self.Acceleration)
        self.DX = max(-self.MySpeedLimit, min(self.MySpeedLimit, self.DX))
        self.DY = max(-self.MySpeedLimit, min(self.MySpeedLimit, self.DY))
        # Find a new target, if we're already where we want to be:
        if abs(DX + DY) < 20 or random.random()<0.001:
            self.WalkToX = random.randrange(30, Global.App.Width - 30)
            self.WalkToY = random.randrange(30, Global.Screen.Bottom - 30)
        self.X += self.DX
        self.Y += self.DY
        self.rect.center = (self.X, self.Y)
    def UpdatePeaceful(self): #UPDATE plugin
        if self.IsGrabbed:
            self.X = Global.PlayerSprite.X + self.GrabX
            self.Y = Global.PlayerSprite.Y + self.GrabY
            self.rect.center = (self.X, self.Y,)
        elif self.IsTossed:
            self.X += self.DX
            self.Y += self.DY
            self.rect.center = (self.X, self.Y,)
        else:
            self.WalkTowardSpot()
        Sprite.AnimateSprite.Update(self)
    def HandleShot(self, ShotSprite):
        self.HP -= ShotSprite.Damage
        ShotSprite.kill()
        if self.HP <= 0:
            self.HandleDeath()
            if Global.Objective.Type == ObjectiveType.KillType and isinstance(self, Global.Objective.Class):
                Global.Player.QuestProgress += 1
                Global.Screen.QuestUpdate()
        else:
            self.DX += ShotSprite.DX
            self.DY += ShotSprite.DY
            self.DX = max(-self.MySpeedLimit, min(self.MySpeedLimit, self.DX))
            self.DY = max(-self.MySpeedLimit, min(self.MySpeedLimit, self.DY))
            Sound.PlaySound(SoundNames.MonsterHit)

class IceCreamSprite(Sprite.AnimateSprite):
    def __init__(self):
        self.X = -50
        self.Y = 670
        self.Pause = 100
        Sprite.AnimateSprite.__init__(self, ImageNames.IceCreamTruck, self.X, self.Y)
    def Update(self):
        self.X += 2
        if self.X > 1050:
            self.kill()
            SongName = random.choice(("Ingame.xm", "Ingame2.xm"))
            Sound.PlaySong(SongName)
            return
        self.rect.center = (self.X, self.Y)
        self.Pause -= 1
        if self.Pause <= 0:
            Item = Items.ItemSprite(self.X, self.Y)
            Item.DY = random.randrange(-50, -10) / 13.0
            Global.Screen.ForegroundSprites.add(Item)
            Global.Screen.ItemSprites.add(Item)
            Global.Screen.BouncySprites.add(Item)
            self.Pause = random.randrange(50, 150)
        Sprite.AnimateSprite.Update(self)
    
class RedAlienSprite(AlienSprite):
    ClassName = "Red Guys"
    Name = ImageNames.RedAlien
    def __init__(self, X, Y):
        if self.SplitCount > 3:
            AlienSprite.__init__(self, self.Name+"Jumbo", X, Y)
        elif self.SplitCount:
            AlienSprite.__init__(self, self.Name+"Large", X, Y)
        else:
            AlienSprite.__init__(self, self.Name, X, Y)
            
class GreenAlienSprite(AlienSprite):
    ClassName = "Green Things"
    Name = ImageNames.GreenAlien
    def __init__(self, X, Y):
        if self.SplitCount > 3:
            AlienSprite.__init__(self, self.Name+"Jumbo", X, Y)
        elif self.SplitCount:
            AlienSprite.__init__(self, self.Name+"Large", X, Y)
        else:
            AlienSprite.__init__(self, self.Name, X, Y)

class BlueAlienSprite(AlienSprite):
    ClassName = "Blue Meanies"
    Name = ImageNames.BlueAlien
    def __init__(self, X, Y):
        if self.SplitCount > 3:
            AlienSprite.__init__(self, self.Name+"Jumbo", X, Y)
        elif self.SplitCount:
            AlienSprite.__init__(self, self.Name+"Large", X, Y)
        else:
            AlienSprite.__init__(self, self.Name, X, Y)
            
class SpaceStationSprite(Sprite.AnimateSprite):
    IsHostile = 1
    Damage = 100
    Speed = 2
    def __init__(self, X, Y, DX, DY):
        Sprite.AnimateSprite.__init__(self, ImageNames.SpaceStation, X, Y, 20)
        self.X = X
        self.Y = Y
        self.DX = DX * self.Speed
        self.DY = DY * self.Speed
        self.SpawnTimer = 10+random.randrange(200)
    def CrashIntoPlayer(self):
        Global.PlayerSprite.BounceOffWall(self)
    def Update(self):
        self.X += self.DX
        self.Y += self.DY
        if self.X < 50:
            self.X = 50
            self.DX = 0
            if (self.Y < 100):
                self.DY = self.Speed
            else:
                self.DY = -self.Speed
        if self.X > 1000:
            self.X = 1000
            self.DX = 0
            if (self.Y < 100):
                self.DY = self.Speed
            else:
                self.DY = -self.Speed
        if self.Y < 50:
            self.Y = 50
            self.DY = 0
            if (self.X < 100):
                self.DX = self.Speed
            else:
                self.DX = -self.Speed
        if self.Y > 680:
            self.Y = 680
            self.DY = 0
            if (self.X < 100):
                self.DX = self.Speed
            else:
                self.DX = -self.Speed
        self.rect.center = (self.X, self.Y)
        self.SpawnTimer -= 1
        if self.SpawnTimer <= 0:
            SpawnCount = 20 - len(Global.Screen.MonsterSprites.sprites())
            if SpawnCount > 0:
                SpawnCount = min(5, max(1, SpawnCount / 5))
                Sound.PlaySound(SoundNames.Spawn)
                for Index in range(SpawnCount):
                    AlienClass = random.choice((RedAlienSprite, GreenAlienSprite, BlueAlienSprite))
                    AlienSprite = AlienClass(self.X, self.Y)
                    AlienSprite.Init()
                    Global.Screen.ForegroundSprites.add(AlienSprite)
                    Global.Screen.MonsterSprites.add(AlienSprite)
                    Global.Screen.BouncySprites.add(AlienSprite)
            self.SpawnTimer = 200 + random.randrange(200)
        Sprite.AnimateSprite.Update(self)
    def HandleShot(self, Shot):
        Sound.PlaySound(SoundNames.Plink)
        Shot.kill()