import pygame
import random

EndSongEvent = pygame.USEREVENT + 1

class Conditions:
    Poison = "Poison"
    Regeneration = "Regeneration"
    Shotgun = "Shotgun"
    Phaser = "Phaser"
    Slow = "Slow"
    Haste = "Haste"
    Money = "Money"
    Confusion = "Confusion"

class ObjectiveType:
    SnakePit = 0
    KillType = 1
    Rescue = 2
    ItemGrab = 3
    BlackHoleToss = 4

class Color:
    Black = (0,0,0)
    White = (255,255,255)
    Blue = (10, 10, 240)
    Green = (10, 240, 10)
    Yellow = (220, 220, 10)
    Red = (240, 10, 10)
    Grey = (170, 170, 170)
    DarkGrey = (90, 90, 90)

class ImageNames:
    Ship = "Ship"
    Shot = "Shot"
    RedShot = "RedShot"
    Exhaust = "Exhaust"
    BlueAlien = "BlueAlien"
    GreenAlien = "GreenAlien"
    RedAlien = "RedAlien"
    BlueAlienLarge = "BlueAlienLarge"
    GreenAlienLarge = "GreenAlienLarge"
    RedAlienLarge = "RedAlienLarge"
    BlueAlienJumbo = "BlueAlienJumbo"
    GreenAlienJumbo = "GreenAlienJumbo"
    RedAlienJumbo = "RedAlienJumbo"
    SpaceStation = "SpaceStation"
    Star = "Star"
    Shrapnel = "Shrapnel"
    BlackHole = "BlackHole"
    SpacePope = "SpacePope"
    Plummet = "Plummet"
    Panic = "Panic"
    ShotGun = "ShotGun"
    Phaser = "Phaser"
    Shield = "Shield"
    ButtTorp = "ButtTorp"
    SnakeHead = "SnakeHead"
    SnakeTail = "SnakeTail"
    IceCreamTruck = "IceCreamTruck"

class SoundNames:
    Hit = "Hit"
    Shot = "Shot"
    SnakeDeath = "SnakeDeath"
    MonsterShot = "MonsterShot"
    Obey = "Obey"
    Spawn = "Spawn"
    PlayerDie = "PlayerDie"
    MonsterDie = "MonsterDie"
    MonsterDie2 = "MonsterDie2"
    SnakeGrow = "SnakeGrow"
    Plink = "Plink"
    PlayerHit = "PlayerHit"
    MonsterHit = "MonsterHit"
    Pause = "Pause"
    LevelComplete = "LevelComplete"
    Plummet = "Plummet"
    Denied = "Denied" # trying to panic with no hp, or entered bad password...
    PickUp = "PickUp"
    PutDown = "PutDown"
    Phaser = "Phaser"
    ShotGun = "ShotGun"
    Panic = "Panic"
    ButtTorp = "ButtTorp"
    Brakes = "Brakes"
    ShieldsUp = "ShieldsUp"
    ShotSnakeTail = "ShotSnakeTail"
    # Items:
    ItemPhaser = "ItemPhaser"
    ItemPoison = "ItemPoison"
    ItemConfusion = "ItemConfusion"
    ItemHealing = "ItemHealing"
    ItemExtraHealing = "ItemExtraHealing"
    ItemRegeneration = "ItemRegeneration"
    ItemSlow = "ItemSlow"
    ItemHaste = "ItemHaste"
    ItemMoney = "ItemMoney"
    ItemShotgun = "ItemShotgun"
    
class KeyCommand:
    Up = 1
    Down = 2
    Left = 3
    Right = 4
    Shot1 = 5
    Shot2 = 6
    AllCommands = [1,2,3,4,5,6]

    