"""
Hi, I'm the image module.
I load images, because that's just the
kind of guy I am.  Now stand aside
and watch...me...rock.
"""
from Constants import *
import pygame
import os
import Global

ImageInfo = {ImageNames.Ship:32,
             ImageNames.Shot:2,
             ImageNames.IceCreamTruck:2,
             ImageNames.Exhaust: 3,
             ImageNames.RedShot:2,
             ImageNames.SpaceStation:3,
             ImageNames.RedAlien:2,
             ImageNames.BlueAlien:2,
             ImageNames.GreenAlien:2,
             ImageNames.RedAlienLarge:2,
             ImageNames.BlueAlienLarge:2,
             ImageNames.GreenAlienLarge:2,
             ImageNames.RedAlienJumbo:2,
             ImageNames.BlueAlienJumbo:2,
             ImageNames.GreenAlienJumbo:2,
             ImageNames.Star:4,
             ImageNames.Shrapnel:4,
             ImageNames.BlackHole:4,
             ImageNames.SpacePope:2,
             ImageNames.Plummet:12,
             ImageNames.Panic:1,
             ImageNames.ShotGun:1,
             ImageNames.Phaser:1,
             ImageNames.Shield:3,
             ImageNames.ButtTorp:2,
             ImageNames.SnakeTail:1,
             ImageNames.SnakeHead:1,
             }
for Letter in ("A", "B", "C", "D", "E", "F"):
    ImageInfo["Item%s"%Letter] = 6

def PrepImages():
    for (Name, ImageCount) in ImageInfo.items():
        ImageList = []
        Warned = 0
        for ImageNumber in range(ImageCount):
            FilePath = os.path.join("Images", "%s%d.png"%(Name, ImageNumber))
            if os.path.exists(FilePath):                                    
                Image = pygame.image.load(FilePath).convert()
            else:
                if not Warned:
                    Warned = 1
                    print "Warning: Missing image %s for %s"%(ImageNumber, Name)
                # Scaffolding backup plan:
                if ImageList:
                    Image = ImageList[0]
                else:
                    print "Warning: NO images found for %s"%Name
                    Image = pygame.Surface((20, 20))
                    Image.fill(Color.White)
            Image.set_colorkey(Color.Black)
            ImageList.append(Image)
        Global.Images[Name] = ImageList