"""
Intro screen.  (NOT USED!!!)
"""
import pygame
import Player
import Sprite
import Sound
import Alien
import time
from Constants import *
from Utils import *

class StarSprite(Sprite.AnimateSprite):
    def __init__(self):
        self.DX = random.randrange(-50, 51) / 10.0
        self.DY = random.randrange(-50, 51) / 10.0
        self.X = self.DX*5 + Global.App.Width / 2
        self.Y = self.DY*5 + Global.App.Height / 2
        Sprite.AnimateSprite.__init__(self, ImageNames.Star, self.X, self.Y)
    def Update(self):
        self.X += self.DX
        self.Y += self.DY
        if self.X < 0 or self.X > 1024:
            self.kill()
            return
        if self.Y < 0 or self.Y > 768:
            self.kill()
            return
        self.rect.center = (self.X, self.Y)
        Sprite.AnimateSprite.Update(self)

class LevelIntroScreen:
    def __init__(self, App):
        self.Surface = App.Surface
        self.BackgroundSurface = App.BackgroundSurface
        self.BackgroundSprites = pygame.sprite.RenderUpdates()
        self.ForegroundSprites = pygame.sprite.RenderUpdates()
        self.AnimationSprites = pygame.sprite.RenderUpdates()
        self.StarSprites = pygame.sprite.RenderUpdates()
        self.Tick = 0
        self.ScreenClosed = 0
        self.MaxTick = 2048
    def RedrawSelf(self):
        self.BackgroundSurface.fill(Color.Black)
        #self.BackgroundSurface.blit(self.BackingSprite.image, (0,0))
        for Sprite in self.BackgroundSprites.sprites():
            self.BackgroundSprites.draw(self.BackgroundSurface)
        MarkDirty([(0, 0,Global.App.Width,Global.App.Height)])
        self.Surface.blit(self.BackgroundSurface,(0,0))
        
    def HandleEvents(self):
        for Event in pygame.event.get():
            self.HandleEvent(Event)
    def HandleEvent(self, Event):
        if Event.type is pygame.QUIT:
            Global.App.QuittingTime = 1
        elif Event.type == EndSongEvent:
            Sound.RepeatSong()
        elif Event.type is pygame.KEYDOWN:
            self.HandleKey(Event.key)
    def HandleKey(self, Key):
        if Key is pygame.K_ESCAPE:
            Global.App.QuittingTime = 1
        elif Key == ord(" "):
            self.DestroyScreen()
    def DestroyScreen(self):
        for Sprite in self.ForegroundSprites.sprites():
            Sprite.kill()
        for Sprite in self.BackgroundSprites.sprites():
            Sprite.kill()
        self.ScreenClosed = 1
            
    def Render(self):
        random.seed(Global.Player.SectorNumber)
        TSprite = Sprite.TextSprite("Sector %d"%Global.Player.SectorNumber, 512, 50, FontSize = 24)
        self.BackgroundSprites.add(TSprite)
        if random.random() > 0.5:
            FirstWords = ("Final", "Dark", "Forgotten", "Ninja", "Deadly", "Merciless")
            LastWords = ("Justice", "Karma", "Fate", "Dragon", "Loaf", "Destiny")
            SectorTitle = "%s %s"%(random.choice(FirstWords), random.choice(LastWords))
        else:
            ThingyWords = ("Nebula", "Dimension", "Vortex", "Realm")
            Adjectives = ("", "", "", "", "",
                          "Plaid ", "Space ", "Mutant ", "Sexy ", "Lazy ",
                          "Angry ", "Purple ", "Glowing ")
            Objects = ("Lightning", "Camels", "Critters", "Zombies", "Bees",
                       "Tyrants", "Sorcery")
            SectorTitle = "The %s of %s%s"%(random.choice(ThingyWords),
                                            random.choice(Adjectives),
                                            random.choice(Objects))
        TSprite = Sprite.TextSprite(SectorTitle, 512, 100, FontSize = 32)
        self.BackgroundSprites.add(TSprite)
        TSprite = Sprite.TextSprite("Your Mission:", 200, 300, FontSize = 32)
        self.BackgroundSprites.add(TSprite)
        ObjectiveText = GetObjectiveDescription(Global.Objective)
        TSprite = Sprite.TextSprite(ObjectiveText, 200, 350, FontSize = 32)
        self.BackgroundSprites.add(TSprite)
        PopeSprite = Sprite.AnimateSprite("SpacePope", 800, 300)
        self.ForegroundSprites.add(PopeSprite)
        TSprite = Sprite.TextSprite("Space Pope says:", 800, 400, FontSize = 32)
        self.BackgroundSprites.add(TSprite)
        TSprite = Sprite.TextSprite("DRINK YOUR OVALTINE.", 800, 450, FontSize = 32)
        self.BackgroundSprites.add(TSprite)
        self.RedrawSelf()
    def Update(self):
        # This screen is boring.  But we do have stars.
        if len(self.StarSprites.sprites()) < 50:
            Sprite = StarSprite()
            self.StarSprites.add(Sprite)
            self.AnimationSprites.add(Sprite)
        for Sprite in self.ForegroundSprites.sprites():
            Sprite.Update()
        for Sprite in self.AnimationSprites.sprites():
            Sprite.Update()
            
    def HandleLoop(self):
        self.Tick = (self.Tick + 1) % self.MaxTick
        self.AnimationSprites.clear(self.Surface, self.BackgroundSurface)
        self.ForegroundSprites.clear(self.Surface, self.BackgroundSurface)
        self.Update()
        if self.ScreenClosed:
            return
        self.HandleEvents()
        if self.ScreenClosed:
            return
        DirtRects = self.ForegroundSprites.draw(self.Surface)
        MarkDirty(DirtRects)
        DirtRects = self.AnimationSprites.draw(self.Surface)
        MarkDirty(DirtRects)

        