"""
Various yummy space junk you can pick up.
"""
from Utils import *
from Constants import *
import Sprite
import Global
import math
import Sound
import random

class ItemSprite(Sprite.AnimateSprite, Sprite.Bouncer):
    def __init__(self, X, Y):
        self.X = X
        self.Y = Y
        self.DX = random.choice((-1, 1)) * random.randrange(10, 20) / 10.0
        self.DY = random.choice((-1, 1)) * random.randrange(10, 20) / 10.0
        self.ItemLetter = random.choice(("A","B","C","D"))
        self.Effect = Global.ItemEffects[self.ItemLetter]
        self.WallHitCount = 0
        Sprite.AnimateSprite.__init__(self, "Item%s"%self.ItemLetter, X, Y, 5)
    def WallReact(self, Wall):
        self.WallHitCount += 1
        if self.WallHitCount > 20:
            Plummet = Sprite.PlummetSprite(self)
            Global.Screen.AnimationSprites.add(Plummet)
            self.kill()
    def Update(self):
        self.X += self.DX
        self.Y += self.DY
        self.rect.center = (self.X, self.Y)
        Sprite.AnimateSprite.Update(self)
    def GetItem(self):
        self.kill()
        
        # Make a sound: %%%
        Sound = Global.Sounds.get("Item%s"%self.Effect, Global.DefaultSound)
        print "GOT ITEM:", self.Effect, Sound
        Sound.play()
        if self.Effect == "Healing":
            Global.Player.Energy = min(Global.Player.Energy + 100, 1000)
        elif self.Effect == "ExtraHealing":
            Global.Player.Energy = min(Global.Player.Energy + 500, 1000)
        elif self.Effect == "Money":
            Global.Player.Score += 1000
        else:
            # Get a condition!
            HaveAlready = Global.Player.Conditions.get(self.Effect, None)
            Duration = 400 # default
            if self.Effect == Conditions.Regeneration:
                Duration = 2000 # long time!
            # Confusion TOGGLES l/r controls:
            if self.Effect == Conditions.Confusion:
                Global.Screen.KeyHandlers[KeyCommand.Left] = Global.PlayerSprite.RotateRight
                Global.Screen.KeyHandlers[KeyCommand.Right] = Global.PlayerSprite.RotateLeft
            if Global.Player.Conditions.has_key(self.Effect):
                Global.Player.Conditions[self.Effect] += Duration/2
            else:
                Global.Player.Conditions[self.Effect] = Duration
            Global.PlayerSprite.UpdateSpeedLimit()