from distutils.core import setup
import glob
import py2exe
import os
import time
import sys

def ListFilesWithExtension(Directory,DesiredExtensions):
    List=[]
    for FileName in os.listdir(Directory):
        Extension = os.path.splitext(FileName)[1]
        if not Extension:
            continue
        Extension = Extension[1:].upper()
        if DesiredExtensions.has_key(Extension):
            FilePath = os.path.join(Directory,FileName)
            List.append(FilePath)
    return List

DataFiles = [\
          (r".",glob.glob(r"*.py")),
          (r".",glob.glob(r"*.xm")),
          (r"Sounds",glob.glob(r"Sounds\*.wav")),
          (r"Images",glob.glob(r"Images\*.png")),
          (r"Fonts",glob.glob(r"Fonts\*.ttf")),
                  ]

def BuildDistribution():
    setup(name="Trouble Shooter",
          description="Adventures in random space",
          version="0.5",
          scripts = ListFilesWithExtension(".", {"PY":1, "PYW":1}),
          console=["Trouble.pyw"],
          data_files = DataFiles,      
    )

if __name__ == "__main__":
    BuildDistribution()
