"""
Simple wrappers for mixer.
"""
import pygame
import os
import sys
from Constants import *
import Global

def PlaySound(Name):
    Sound = Global.Sounds.get(Name, Global.DefaultSound)
    Sound.play()

def RepeatSong():
    if Global.CurrentSong:
        PlaySong(Global.CurrentSong)
        
def PlaySong(Path):
    if Global.CurrentSong:
        print "Stop current:"
        pygame.mixer.music.stop()
        print "Stopped."
        Global.CurrentSong = None
    Global.CurrentSong = Path
    #Path = os.path.join("Sounds", "%s.xm"%Global.CurrentSong)
    pygame.event.pump()
    pygame.mixer.music.load(Path)
    print "Play it..."
    pygame.mixer.music.play()
    pygame.mixer.music.set_endevent(EndSongEvent)
    print "Ok!"
    
def PrepSounds():
    for SoundName in dir(SoundNames):
        Global.DefaultSound = pygame.mixer.Sound(os.path.join("Sounds", "Default.wav"))
        if SoundName[0]=="_":
            continue
        SoundPath = os.path.join("Sounds", "%s.wav"%SoundName)
        if not os.path.exists(SoundPath):
            print "Warning: No sound '%s'"%SoundName
            Sound = Global.DefaultSound
        else:
            Sound = pygame.mixer.Sound(SoundPath)
        Global.Sounds[SoundName] = Sound